/*
Created by: X
http://www.createdbyx.com/

xFripperyXNA is licenced under the Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Canada
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/
*/
using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;

namespace xFripperyXNA
{
    public delegate void ClickEventHandler(object sender, PointerButtons b, Vector2 pos);
    public delegate void PointerDownEventHandler(object sender, PointerButtons b, Vector2 pos);
    public delegate void PointerMoveEventHandler(object sender, PointerButtons b, Vector2 pos);
    public delegate void PointerUpEventHandler(object sender, PointerButtons b, Vector2 pos);
    public delegate void KeyUpEventHandler(object sender, Keys e);
    public delegate void KeyDownEventHandler(object sender, Keys e);
    public delegate void KeyClickEventHandler(object sender, Keys e);
    public delegate void WidthEventHandler(object sender, int value, int oldvalue);
    public delegate void HeightEventHandler(object sender, int value, int oldvalue);
    public delegate void BoundsEventHandler(object sender, Rectangle value, Rectangle oldvalue);

    public interface IControl: ICloneable 
    {
        IControl GetControlFromPoint(float X, float Y);
        AnchorStyles Anchor { get; set; }   
        int Height { get; set; }                                   
        int Width { get; set; }                                    
        int Top { get; set; }                                      
        int Left { get; set; }                                     
        Rectangle Bounds { get; set; }
        Rectangle ScreenBounds { get; }
        Vector2 PointToScreen(Vector2 Pt);            
        Vector2 PointToClient(Vector2 Pt);
        Vector2 PointToScreen(float x, float y);
        Vector2 PointToClient(float x, float y);
        void MoveToFront();
        void MoveToBack(); 
        string Data { get; set; }       
        string Name { get; set; }       
        void RaisePointerDown(object sender, PointerButtons b, Vector2 pos);
        void RaisePointerMove(object sender, PointerButtons b, Vector2 pos);
        void RaisePointerUp(object sender, PointerButtons b, Vector2 pos);
        void RaiseClick(object sender, PointerButtons b, Vector2 pos);
        ControlCollection Children { get; set; }
        IControl Parent { get; set; }
        bool Visible { get; set; }
     
        event ClickEventHandler Click;
        event PointerDownEventHandler PointerDown;
        event PointerMoveEventHandler PointerMove;
        event PointerUpEventHandler PointerUp;
        event KeyUpEventHandler KeyUp;
        event KeyDownEventHandler KeyDown;
        event KeyClickEventHandler KeyClick;
        event WidthEventHandler WidthChanged;
        event HeightEventHandler HeightChanged;
        event BoundsEventHandler BoundsChanged;
    }
}
