/*
Created by: X
http://www.createdbyx.com/

xMessages is licenced under the Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Canada
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/
*/
using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace xMessages.ImageEffects
{
    public class PlainImage : IImageEffect, IDisposable
    {
        internal Texture2D image;
        private Rectangle imageSource;
        private Color imageColor = Color.White;

        #region IImageEffect Members

        public void Reset()
        {
           // does nothing
        }

        public void Update(Microsoft.Xna.Framework.GameTime gameTime, MessageInformation e, Rectangle rect)
        {
           // does nothing
        }

        public void Draw(Microsoft.Xna.Framework.GameTime gameTime, MessageInformation e, Rectangle rect, SpriteBatch spriteBatch)
        {
            if (e == null) return;
            if (spriteBatch == null) return;
            // check if the currently displayed message has an image associated with it.
            if (this.image == null) return;

           spriteBatch.Draw(this.image, rect, this.imageSource, this.imageColor);
        }


        #endregion


        /// <summary>
        /// Gets/Sets the color of the image that is displayed.
        /// </summary>
        public Color ImageColor
        {
            get { return imageColor; }
            set { imageColor = value; }
        }


        /// <summary>
        /// Gets/Sets the source rectangle for the image.
        /// </summary>
        public Rectangle ImageSourceRectangle
        {
            get { return imageSource; }
            set { imageSource = value; }
        }

        /// <summary>
        /// Gets/Sets the image to be used with the image.
        /// </summary>
        public Texture2D Image
        {
            get { return image; }
            set { image = value; }
        }



        #region IDisposable Members

        public void Dispose()
        {
           // throw new Exception("The method or operation is not implemented.");
        }

        #endregion
    }
}
