/*
Created by: X
http://www.createdbyx.com/

xMessages is licenced under the Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Canada
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/
*/
using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace xMessages
{
    public class MessageControl : xFripperyXNA.Control,  IMessageControl
    {
        protected Rectangle destRect;
        protected Rectangle srcRect;
        protected Texture2D texture;
        protected Color color = Color.White;

        /// <summary>
        /// Allows the game component to draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        public virtual void Draw(GameTime gameTime, SpriteBatch sb)
        {
            this.Draw(this, gameTime, sb);
        }

        protected virtual void Draw(IMessageControl c, GameTime gameTime, SpriteBatch sb)
        {
            if (!this.Visible) { return; }

            if (this.texture != null)
            {
                // calc dest rect
                Vector2 v = new Vector2(this.Left, this.Top);
                if (this.Parent != null)
                {
                    v = this.Parent.PointToScreen(new Vector2(this.Left, this.Top));
                }
                Rectangle dr = new Rectangle((int)v.X, (int)v.Y, this.Width, this.Height);

                // draw control
                sb.Draw(this.texture, dr, this.srcRect, this.color);
            }

            // draw any children  
            foreach (IMessageControl child in this.children)
            {
                child.Draw(gameTime, sb);
            }
        }

        #region IPanel Members

        public Rectangle SourceRectangle
        {
            get
            {
                return this.srcRect;
            }
            set
            {
                this.srcRect = value;
            }
        }

        public Texture2D Texture
        {
            get
            {
                return this.texture;
            }
            set
            {
                this.texture = value;
            }
        }

        public Color Color
        {
            get
            {
                return this.color;
            }
            set
            {
                this.color = value;
            }
        }

        #endregion
    }
}
